package org.wfc.omada.api.sitesetting.model;

import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import javax.validation.Valid;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Pattern;
import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

/**
 * OUIProfileQueryOpenApiVO
 */
@ApiModel(description = "OUIProfileQueryOpenApiVO")
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.SpringCodegen", date = "2024-12-04T11:32:19.054+08:00[Asia/Shanghai]")

public class OuiProfileQueryOpenApiVo   {
  @JsonProperty("id")
  private String id;

  @JsonProperty("name")
  private String name;

  @JsonProperty("count")
  private Integer count;

  @JsonProperty("ouiCombine")
  @Valid
  private List<OuiAndDescription> ouiCombine = null;

  public OuiProfileQueryOpenApiVo id(String id) {
    this.id = id;
    return this;
  }

  /**
   * OUI Profile ID
   * @return id
  */
  @ApiModelProperty(value = "OUI Profile ID")


  public String getId() {
    return id;
  }

  public void setId(String id) {
    this.id = id;
  }

  public OuiProfileQueryOpenApiVo name(String name) {
    this.name = name;
    return this;
  }

  /**
   * OUI Profile name should contain 1 to 64 characters.
   * @return name
  */
  @ApiModelProperty(required = true, value = "OUI Profile name should contain 1 to 64 characters.")
  @NotNull

@Pattern(regexp="^[^ ]$|^[^ ].{0,62}[^ ]$") 
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public OuiProfileQueryOpenApiVo count(Integer count) {
    this.count = count;
    return this;
  }

  /**
   * OUI Profile count
   * @return count
  */
  @ApiModelProperty(value = "OUI Profile count")


  public Integer getCount() {
    return count;
  }

  public void setCount(Integer count) {
    this.count = count;
  }

  public OuiProfileQueryOpenApiVo ouiCombine(List<OuiAndDescription> ouiCombine) {
    this.ouiCombine = ouiCombine;
    return this;
  }

  public OuiProfileQueryOpenApiVo addOuiCombineItem(OuiAndDescription ouiCombineItem) {
    if (this.ouiCombine == null) {
      this.ouiCombine = new ArrayList<>();
    }
    this.ouiCombine.add(ouiCombineItem);
    return this;
  }

  /**
   * OUI and description
   * @return ouiCombine
  */
  @ApiModelProperty(value = "OUI and description")

  @Valid

  public List<OuiAndDescription> getOuiCombine() {
    return ouiCombine;
  }

  public void setOuiCombine(List<OuiAndDescription> ouiCombine) {
    this.ouiCombine = ouiCombine;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    OuiProfileQueryOpenApiVo ouiProfileQueryOpenApiVo = (OuiProfileQueryOpenApiVo) o;
    return Objects.equals(this.id, ouiProfileQueryOpenApiVo.id) &&
        Objects.equals(this.name, ouiProfileQueryOpenApiVo.name) &&
        Objects.equals(this.count, ouiProfileQueryOpenApiVo.count) &&
        Objects.equals(this.ouiCombine, ouiProfileQueryOpenApiVo.ouiCombine);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, name, count, ouiCombine);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class OuiProfileQueryOpenApiVo {\n");
    
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    count: ").append(toIndentedString(count)).append("\n");
    sb.append("    ouiCombine: ").append(toIndentedString(ouiCombine)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

